Package org.apache.commons.jxpath.ri.model.beans

# Class NullPointer

java.lang.Object
org.apache.commons.jxpath.ri.model.NodePointer
org.apache.commons.jxpath.ri.model.beans.PropertyOwnerPointer
org.apache.commons.jxpath.ri.model.beans.NullPointer

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `Comparable`, `Pointer`

public class NullPointer extends PropertyOwnerPointer
Pointer whose value is `null`.

See Also:
  - Serialized Form

- ## Field Summary

  ### Fields inherited from class org.apache.commons.jxpath.ri.model.NodePointer

  `index, locale, parent, UNKNOWN_NAMESPACE, WHOLE_COLLECTION`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `NullPointer(Locale locale, String id)`
  Constructs a new NullPointer.
  `NullPointer(NodePointer parent, QName qName)`
  Used for the root node.
  `NullPointer(QName qName, Locale locale)`
  Constructs a new NullPointer.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `asPath()`
  Returns an XPath that maps to this Pointer.
  `NodePointer`
  `createChild(JXPathContext context, QName qName, int index)`
  Called by a child pointer when it needs to create a parent object for a non-existent collection element.
  `NodePointer`
  `createChild(JXPathContext context, QName qName, int index, Object value)`
  Called by a child pointer if that child needs to assign the value supplied in the createPath(context, value) call to a non-existent node.
  `NodePointer`
  `createPath(JXPathContext context)`
  Called by a child pointer when it needs to create a parent object.
  `NodePointer`
  `createPath(JXPathContext context, Object value)`
  Called directly by JXPathContext.
  `boolean`
  `equals(Object object)`
  `Object`
  `getBaseValue()`
  Gets the value represented by the pointer before indexing.
  `int`
  `getLength()`
  If the pointer represents a collection (or collection element), returns the length of the collection.
  `QName`
  `getName()`
  Gets the name of this node.
  `PropertyPointer`
  `getPropertyPointer()`
  Gets a PropertyPointer for this PropertyOwnerPointer.
  `int`
  `hashCode()`
  `boolean`
  `isActual()`
  An actual pointer points to an existing part of an object graph, even if it is null.
  `boolean`
  `isCollection()`
  Returns `true` if the value of the pointer is an array or a Collection.
  `boolean`
  `isLeaf()`
  If true, this node does not have children

  ### Methods inherited from class org.apache.commons.jxpath.ri.model.beans.PropertyOwnerPointer

  `attributeIterator, childIterator, compareChildNodePointers, createNodeIterator, getImmediateNode, isDynamicPropertyDeclarationSupported, isValidProperty, remove, setIndex, setValue`

  ### Methods inherited from class org.apache.commons.jxpath.ri.model.NodePointer

  `clone, compareTo, createAttribute, escape, getAbstractFactory, getDefaultNamespaceURI, getImmediateParentPointer, getImmediateValuePointer, getIndex, getLocale, getNamespaceResolver, getNamespaceURI, getNamespaceURI, getNode, getNodeSetByKey, getNodeValue, getParent, getPointerByID, getPointerByKey, getRootNode, getValue, getValuePointer, handle, handle, isAttribute, isContainer, isDefaultNamespace, isLanguage, isNode, isRoot, namespaceIterator, namespacePointer, newChildNodePointer, newNodePointer, printPointerChain, setAttribute, setExceptionHandler, setNamespaceResolver, testNode, toString, verify`

  ### Methods inherited from class java.lang.Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### NullPointer

    public NullPointer(Locale locale, String id)
    Constructs a new NullPointer.
    Parameters:
      `locale` - Locale.
      `id` - ID.

  - ### NullPointer

    public NullPointer(NodePointer parent, QName qName)
    Used for the root node.
    Parameters:
      `parent` - parent pointer
      `qName` - node name

  - ### NullPointer

    public NullPointer(QName qName, Locale locale)
    Constructs a new NullPointer.
    Parameters:
      `qName` - node name
      `locale` - Locale

- ## Method Details

  - ### asPath

    public String asPath()
    Description copied from class: `NodePointer`
    Returns an XPath that maps to this Pointer.
    Specified by:
      `asPath` in interface `Pointer`
    Overrides:
      `asPath` in class `NodePointer`
    Returns:
      String XPath expression

  - ### createChild

    public NodePointer createChild(JXPathContext context, QName qName, int index)
    Description copied from class: `NodePointer`
    Called by a child pointer when it needs to create a parent object for a non-existent collection element. It may have to expand the collection, then create an element object and return a new pointer describing the newly created element.
    Overrides:
      `createChild` in class `NodePointer`
    Parameters:
      `context` - the owning JXPathCOntext
      `qName` - the QName at which a child should be created
      `index` - child index.
    Returns:
      created NodePointer

  - ### createChild

    public NodePointer createChild(JXPathContext context, QName qName, int index, Object value)
    Description copied from class: `NodePointer`
    Called by a child pointer if that child needs to assign the value supplied in the createPath(context, value) call to a non-existent node. This method may have to expand the collection in order to assign the element.
    Overrides:
      `createChild` in class `NodePointer`
    Parameters:
      `context` - the owning JXPathCOntext
      `qName` - the QName at which a child should be created
      `index` - child index.
      `value` - node value to set
    Returns:
      created NodePointer

  - ### createPath

    public NodePointer createPath(JXPathContext context)
    Description copied from class: `NodePointer`
    Called by a child pointer when it needs to create a parent object. Must create an object described by this pointer and return a new pointer that properly describes the new object.
    Overrides:
      `createPath` in class `NodePointer`
    Parameters:
      `context` - the owning JXPathContext
    Returns:
      created NodePointer

  - ### createPath

    public NodePointer createPath(JXPathContext context, Object value)
    Description copied from class: `NodePointer`
    Called directly by JXPathContext. Must create path and set value.
    Overrides:
      `createPath` in class `NodePointer`
    Parameters:
      `context` - the owning JXPathContext
      `value` - the new value to set
    Returns:
      created NodePointer

  - ### equals

    public boolean equals(Object object)
    Overrides:
      `equals` in class `Object`

  - ### getBaseValue

    public Object getBaseValue()
    Description copied from class: `NodePointer`
    Gets the value represented by the pointer before indexing. So, if the node represents an element of a collection, this method returns the collection itself.
    Specified by:
      `getBaseValue` in class `NodePointer`
    Returns:
      Object value

  - ### getLength

    public int getLength()
    Description copied from class: `NodePointer`
    If the pointer represents a collection (or collection element), returns the length of the collection. Otherwise returns 1 (even if the value is null).
    Specified by:
      `getLength` in class `NodePointer`
    Returns:
      the length.

  - ### getName

    public QName getName()
    Description copied from class: `NodePointer`
    Gets the name of this node. Can be null.
    Specified by:
      `getName` in class `PropertyOwnerPointer`
    Returns:
      QName The name of this node. Can be null.

  - ### getPropertyPointer

    public PropertyPointer getPropertyPointer()
    Description copied from class: `PropertyOwnerPointer`
    Gets a PropertyPointer for this PropertyOwnerPointer.
    Specified by:
      `getPropertyPointer` in class `PropertyOwnerPointer`
    Returns:
      PropertyPointer

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`

  - ### isActual

    public boolean isActual()
    Description copied from class: `NodePointer`
    An actual pointer points to an existing part of an object graph, even if it is null. A non-actual pointer represents a part that does not exist at all. For instance consider the pointer "/address/street". If both address and street are not null, the pointer is actual. If address is not null, but street is null, the pointer is still actual. If address is null, the pointer is not actual. (In JavaBeans) if address is not a property of the root bean, a Pointer for this path cannot be obtained at all - actual or otherwise.
    Overrides:
      `isActual` in class `NodePointer`
    Returns:
      boolean

  - ### isCollection

    public boolean isCollection()
    Description copied from class: `NodePointer`
    Returns `true` if the value of the pointer is an array or a Collection.
    Specified by:
      `isCollection` in class `NodePointer`
    Returns:
      boolean

  - ### isLeaf

    public boolean isLeaf()
    Description copied from class: `NodePointer`
    If true, this node does not have children
    Specified by:
      `isLeaf` in class `NodePointer`
    Returns:
      boolean